unit hwunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SmartPort, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    Button3: TButton;
    Button4: TButton;
    Timer1: TTimer;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    Button5: TButton;
    SmartPort1: TSmartPort;
    GroupBox4: TGroupBox;
    Button6: TButton;
    GroupBox5: TGroupBox;
    Bit1: TCheckBox;
    Bit0: TCheckBox;
    Bit2: TCheckBox;
    Bit3: TCheckBox;
    Bit4: TCheckBox;
    Bit5: TCheckBox;
    Bit6: TCheckBox;
    Bit7: TCheckBox;
    GroupBox6: TGroupBox;
    Error: TCheckBox;
    Select: TCheckBox;
    PE: TCheckBox;
    Ask: TCheckBox;
    Busy: TCheckBox;
    RadioGroup1: TRadioGroup;
    LPT1: TRadioButton;
    LPT2: TRadioButton;
    Button8: TButton;
    GroupBox7: TGroupBox;
    Edit1: TEdit;
    GroupBox8: TGroupBox;
    Button7: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    GroupBox9: TGroupBox;
    Button9: TButton;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SmartPort1HardwareInterrupt;
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    dwCounter: DWORD;
    BASE: WORD;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Label1.Caption:='IRQ Not Set';
 Button2.Caption:='Set IRQ';
 Button3.Caption:='Unmask IRQ';
 Panel1.Caption:='0'; dwCounter:=0;
 if SmartPort1.Active then
 begin SmartPort1.Active:=false; Button1.Caption:='Open Driver' end
 else SmartPort1.Active:=true;
 if SmartPort1.Active then Button1.Caption:='Close Driver';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 Button3.Caption:='Unmask IRQ';
 Panel1.Caption:='0'; dwCounter:=0;
 if SmartPort1.ActiveIRQ then
 begin
  SmartPort1.ActiveIRQ:=false;
  Label1.Caption:='IRQ Not Set';
  Button2.Caption:='Set IRQ';
  Timer1.Enabled:=false;
 end
 else
 begin
  SmartPort1.IRQ:=SpinEdit1.Value;
  dwCounter:=0;
  Panel1.Caption:='0';
  SmartPort1.ActiveIRQ:=true;
  sleep(50);
  if SmartPort1.ActiveIRQ then
  begin
   Label1.Caption:='IRQ # '+IntToStr(SmartPort1.IRQ);
   Button2.Caption:='Stop IRQ';
   Timer1.Enabled:=TRUE;
  end
 end;
end;

procedure TForm1.SmartPort1HardwareInterrupt;
begin
  dwCounter:=dwCounter+1;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Panel1.Caption:=IntToStr(dwCounter);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 dwCounter:=0; Panel1.Caption:='0';
 if SmartPort1.IRQMasked then
  begin SmartPort1.IRQMasked:=FALSE; Button3.Caption:='Mask IRQ' end
 else begin SmartPort1.IRQMasked:=TRUE; Button3.Caption:='Unmask IRQ' end
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 SmartPort1.SimulateIRQ;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 SmartPort1.Sound(1100,300);
 SmartPort1.Sound(1247,300);
 SmartPort1.Sound(1393,300);
 SmartPort1.Sound(1466,300);
 SmartPort1.Sound(1613,300);
 SmartPort1.Sound(1760,300);
 SmartPort1.Sound(2052,300);
 SmartPort1.Sound(2198,500);
end;

procedure TForm1.Button6Click(Sender: TObject);
var b,b1: BYTE;
begin
 if SmartPort1.Active then
 begin
  if LPT1.Checked then BASE:=$378 else BASE:=278;
  b:=SmartPort1.Port[BASE];
  b1:=SmartPort1.Port[BASE+1];
  if(b1 and $08)<>0 then Error.Checked:=true else Error.Checked:=false;
  if(b1 and $10)<>0 then Select.Checked:=true else Select.Checked:=false;
  if(b1 and $20)<>0 then PE.Checked:=true else PE.Checked:=false;
  if(b1 and $40)<>0 then ASK.Checked:=true else ASK.Checked:=false;
  if(b1 and $80)<>0 then BUSY.Checked:=true else BUSY.Checked:=false;
  if(b and $01)<>0 then Bit0.Checked:=true else Bit0.Checked:=false;
  if(b and $02)<>0 then Bit1.Checked:=true else Bit1.Checked:=false;
  if(b and $04)<>0 then Bit2.Checked:=true else Bit2.Checked:=false;
  if(b and $08)<>0 then Bit3.Checked:=true else Bit3.Checked:=false;
  if(b and $10)<>0 then Bit4.Checked:=true else Bit4.Checked:=false;
  if(b and $20)<>0 then Bit5.Checked:=true else Bit5.Checked:=false;
  if(b and $40)<>0 then Bit6.Checked:=true else Bit6.Checked:=false;
  if(b and $80)<>0 then Bit7.Checked:=true else Bit7.Checked:=false;
 end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 if SmartPort1.Active then
 begin
  if LPT1.Checked then BASE:=$378 else BASE:=278;
  SmartPort1.Port[$378]:=SpinEdit2.Value;
 end; 
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
 Form1.Close;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
 SmartPort1.Sound(StrToIntDef(Edit1.Text,440),200);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 SmartPort1.ActiveIRQ:=false;
 SmartPort1.Active:=false;
 Timer1.Enabled:=false;
end;

end.
